<script setup lang="ts">
import type { BaseCTA, DynamicComponent } from '@/types/base';

interface SideNavigation {
  links: Array<BaseCTA>;
  components: Array<DynamicComponent<never>>;
}

const content = defineProps<SideNavigation>();

const components = await useDynamicComponents(content.components);
const navLinks = computed(() => {
  return content.links.map((link) => ({
    text: link.text,
    id: link.config?.id,
  }));
});
</script>

<template>
  <SlpSection>
    <SlpSideNavigation :navigation-items="navLinks" class="side-navigation-override">
      <template v-for="(component, index) in components" :key="`side-nav-component-${index}`">
        <keep-alive>
          <component
            :is="component.resolvedComponent.default"
            v-bind="component.componentContent"
            :id="component.componentContent.config?.id"
          />
        </keep-alive>
      </template>
    </SlpSideNavigation>
  </SlpSection>
</template>

<style scoped lang="scss">
.side-navigation-override {
  margin-top: 32px;
  @media (min-width: $breakpoint-md) {
    margin-top: 64px;
  }
  @media (min-width: $breakpoint-lg) {
    gap: 32px;
  }
  @media (min-width: $breakpoint-xl) {
    gap: 64px;
  }
}
:deep(.side-navigation-content) {
  & > :first-child {
    padding-top: 0 !important;
  }
}
</style>
